#include <iostream>
#include <string>
#include <stack>
using namespace std;

const int MAX_DIM = 8;
int dim, ruutude_arv;

// massiiv, mis on abiks arvutamisel, kuhu ratsu kia saab (st naabertippude leidmiseks graafis)
int deltad[8][2] =
{{-2, -1}, {-2, 1}, {2, -1}, {2, 1}, {1, 2}, {1, -2}, {-1, 2}, {-1, -2}};
bool kaidud[MAX_DIM][MAX_DIM] = { 0, 0 };
stack<string> vastus;
bool Otsi(int x, int y, int kaigu_nr);

int main()
{
    cin >> dim;
    ruutude_arv = dim*dim;
    string algus;
    cin >> algus;
    if (Otsi(algus[0]-'a', algus[1]-'1', 1)) {
        while (vastus.size()) {
            cout << vastus.top() << " ";
            vastus.pop();
        }
    }
    else
        cout << "EI SAA" << endl;
}

bool Otsi(int x, int y, int kaigu_nr)
{
    if (kaigu_nr == ruutude_arv) return true; // kik ruudud on kidud, tee on leitud
    kaidud[x][y] = true; // siin me oleme

    for (int k = 0; k < 8; k++) { // iga vimaliku kigu jaoks
        int naaber_x = x + deltad[k][0]; 
        int naaber_y = y + deltad[k][1];
        if ((naaber_x < 0) || (naaber_x >= dim) || // kui on vljaspool..
            (naaber_y < 0) || (naaber_y >= dim) || //..mngulauda
            kaidud[naaber_x][naaber_y]) { // vi on juba kidud,
            continue; // pole sobiv sihtkoht, jtkame
        }
        if (Otsi(naaber_x, naaber_y, kaigu_nr + 1)) { // Proovime jrgmist kiku
            vastus.push(string() + (char)(naaber_x + 'a') + (char)(naaber_y + '1'));
            return true;
        }
    }   
    // ei leidnud teed, mis lbiks kik ruudud
    kaidud[x][y] = false; // vtame viimase kigu tagasi
    return false;
}