#include <vector>
#include <queue>
#include <iostream>
#include <sstream>
#include <string>
using namespace std;

const int MAX_TIPPE = 1000;
vector<int> graaf[MAX_TIPPE];
int tippude_arv;
vector<int> jaotus(MAX_TIPPE, -1);

void loegraaf() {
    cin >> tippude_arv;
    string s;
    while (getline(cin, s)){
        istringstream ss(s);
        int tipp, naaber;
        ss >> tipp;
        while (ss >> naaber){
            graaf[tipp - 1].push_back(naaber - 1);
        }
    }
}

bool jaota()
{
    queue<int> jrkd;
    jrkd.push(0);
    jaotus[0] = 0;

    while (!jrkd.empty()) {
        int u = jrkd.front();
        jrkd.pop();
        for (int i = 0; i < (int)graaf[u].size(); i++) {
            int v = graaf[u][i];
            if (jaotus[v] == -1) {// kui naaber ei ole veel jaotatud
                jaotus[v] = 1 - jaotus[u]; // paneme talle teise vrtuse
                jrkd.push(v); // ja lisame jrjekorda
            }
            else if (jaotus[v] == jaotus[u]) { // kui serv on kahe sama omadusega tipu vahel 
                return false; // siis jrelikult graaf ei ole kahealuseline
            }
            // juhul, kui naaber on juba jaotatud, aga teist vrvi, on kik korras, jtkame
        }
    }
    return true;
}

int main()
{
    loegraaf();
    if (jaota())
        cout << "Graaf on kahealuseline";
    else
        cout << "Graaf ei ole kahealuseline";
    return 0;
}
