#include <iostream>
#include <string>
#include <queue>
#include <map>
using namespace std;

const int MAX_DIM = 100;
int dim, ruutude_arv;

// massiiv, mis on abiks arvutamisel, kuhu ratsu kia saab (st naabertippude leidmiseks graafis)
int deltad[8][2] =
{{-2, -1}, {-2, 1}, {2, -1}, {2, 1}, {1, 2}, {1, -2}, {-1, 2}, {-1, -2}};
bool kaidud[MAX_DIM][MAX_DIM] = {0, 0};
void otsi(pair<int, int> algus, pair<int, int> lopp);

int main()
{
    cin >> dim;
    string salgus, slopp;
    cin >> salgus >> slopp;
    pair<int,int> algus = make_pair(salgus[0] - 'a', salgus[1] - '1');
    pair<int, int> lopp = make_pair(slopp[0] - 'a', slopp[1] - '1');
    otsi(algus, lopp);
}

void otsi(pair<int, int> algus, pair<int, int> lopp)
{
    queue<pair<int, int>> jarjekord;
    // Siin hoiame iga ruudu jaoks meeles lhima tee, kuidas sinna algusest sai.
    map<pair<int, int>, string> teed;

    jarjekord.push(algus);
    kaidud[algus.first][algus.second] = true;
    teed[algus] = string() + char(algus.first + 'a') + char(algus.second + '1');

    while (!jarjekord.empty()) {
        pair<int, int> ruut = jarjekord.front();
        jarjekord.pop();
        if (lopp == ruut) { // oleme judnud sihtkohta
            cout << teed[ruut] << endl; // vljastame tee
            return; // rohkem otsida pole vaja
        }

        for (int k = 0; k < 8; k++) { // iga vimaliku kigu jaoks
            int x = ruut.first + deltad[k][0];
            int y = ruut.second + deltad[k][1];
            if ((x >= 0) && (x < dim) && (y >= 0) && (y < dim) && //mngulaual
                !kaidud[x][y]) { // ja kimata
                jarjekord.push(make_pair(x, y));
                kaidud[x][y] = true;              
               // Laiuti lbimise puhul kohe kui uuele ruudule juame, on see lhim  
               // vimalik tee servade arvu mttes. Jtame selle tee meelde
                teed[make_pair(x, y)] = teed[ruut] + " " + char(x + 'a') + char(y + '1');
            }
        }
    }
   cout << "EI SAA" << endl; // ei ole teed leidnud
}