#include <iostream>
#include <string>
using namespace std;

const int MAX_DIM = 100;
int dim, ruutude_arv;

// massiiv, mis on abiks arvutamisel, kuhu ratsu kia saab (st naabertippude leidmiseks graafis)
int deltad[8][2] =
{ { -2, -1 }, { -2, 1 }, { 2, -1 }, { 2, 1 }, { 1, 2 }, { 1, -2 }, { -1, 2 }, { -1, -2 } };
bool kaidud[MAX_DIM][MAX_DIM] = { 0, 0 };
void otsi(int x, int y);

int main()
{
    int etturid, ratsud=0;
    cin >> dim >> etturid;
    for (int i = 0; i < etturid; i++) {
        string ettur;
        cin >> ettur;
        kaidud[ettur[0] - 'a'][ettur[1] - '1'] = true;
    }

    for (int i = 0; i < dim; i++)
        for (int j = 0; j < dim; j++) {
            if (!kaidud[i][j]){
                ratsud++;
                otsi(i, j);
            }
        }
    cout << ratsud << endl;
}

void otsi(int x, int y)
{
    kaidud[x][y] = true;

    for (int k = 0; k < 8; k++) {
        int naaber_x = x + deltad[k][0];
        int naaber_y = y + deltad[k][1];
        if ((naaber_x >= 0) && (naaber_x < dim) && // mngulaual
            (naaber_y >= 0) && (naaber_y < dim) && 
            !kaidud[naaber_x][naaber_y]) { // ja kimata
                otsi(naaber_x, naaber_y);
        }
    }
}
